tbb::interface10::internal::concurrent_skip_list< Traits >::const_range_type Class Reference

`#include <_concurrent_skip_list_impl.h>`

Inheritance diagram for tbb::interface10::internal::concurrent_skip_list< Traits >::const_range_type:
Collaboration diagram for tbb::interface10::internal::concurrent_skip_list< Traits >::const_range_type:

## Public Types

using | size_type = typename concurrent_skip_list::size_type
using | value_type = typename concurrent_skip_list::value_type
using | iterator = typename concurrent_skip_list::const_iterator

## Public Member Functions

bool | empty () const
bool | is_divisible () const
size_type | size () const
| const_range_type (const_range_type &r, split)
| const_range_type (const concurrent_skip_list &l)
iterator | begin () const
iterator | end () const
size_t | grainsize () const

## Private Attributes

const_iterator | my_end
const_iterator | my_begin
size_type | my_level

## Additional Inherited Members

Private Member Functions inherited from tbb::internal::no_assign
void | operator= (const no_assign &)=delete
| no_assign (const no_assign &)=default
| no_assign ()=default

## Detailed Description

### template<typename Traits>
class tbb::interface10::internal::concurrent_skip_list< Traits >::const_range_type

Definition at line 618 of file _concurrent_skip_list_impl.h.

## Member Typedef Documentation

## iterator

template<typename Traits >

using tbb::interface10::internal::concurrent_skip_list< Traits >::const_range_type::iterator = typename concurrent_skip_list::const_iterator

Definition at line 622 of file _concurrent_skip_list_impl.h.

## size_type

template<typename Traits >

using tbb::interface10::internal::concurrent_skip_list< Traits >::const_range_type::size_type = typename concurrent_skip_list::size_type

Definition at line 620 of file _concurrent_skip_list_impl.h.

## value_type

template<typename Traits >

using tbb::interface10::internal::concurrent_skip_list< Traits >::const_range_type::value_type = typename concurrent_skip_list::value_type

Definition at line 621 of file _concurrent_skip_list_impl.h.

## Constructor & Destructor Documentation

## const_range_type() [1/2]

template<typename Traits >

tbb::interface10::internal::concurrent_skip_list< Traits >::const_range_type::const_range_type | ( | const_range_type & | r,
|  | split |
| ) |  |

inline

Definition at line 640 of file _concurrent_skip_list_impl.h.

: my_end(r.my_end) {
my_begin = iterator(r.my_begin.my_node_ptr->next(r.my_level - 1));
my_level = my_begin.my_node_ptr->height();
r.my_end = my_begin;
}

References tbb::interface10::internal::concurrent_skip_list< Traits >::const_range_type::my_begin, tbb::interface10::internal::concurrent_skip_list< Traits >::const_range_type::my_end, tbb::interface10::internal::concurrent_skip_list< Traits >::const_range_type::my_level, and tbb::interface10::internal::skip_list_iterator< NodeType, is_const >::my_node_ptr.

## const_range_type() [2/2]

template<typename Traits >

tbb::interface10::internal::concurrent_skip_list< Traits >::const_range_type::const_range_type | ( | const concurrent_skip_list & | l | ) |

inline

Definition at line 647 of file _concurrent_skip_list_impl.h.

: my_end(l.end()), my_begin(l.begin()), my_level(my_begin.my_node_ptr->height() ) {}

## Member Function Documentation

## begin()

template<typename Traits >

iterator tbb::interface10::internal::concurrent_skip_list< Traits >::const_range_type::begin | ( |  | ) | const

inline

Definition at line 650 of file _concurrent_skip_list_impl.h.

{ return my_begin; }

References tbb::interface10::internal::concurrent_skip_list< Traits >::const_range_type::my_begin.

Referenced by tbb::interface10::internal::concurrent_skip_list< Traits >::range_type::begin().

Here is the caller graph for this function:

## empty()

template<typename Traits >

bool tbb::interface10::internal::concurrent_skip_list< Traits >::const_range_type::empty | ( |  | ) | const

inline

Definition at line 630 of file _concurrent_skip_list_impl.h.

{
return my_begin.my_node_ptr->next(0) == my_end.my_node_ptr;
}

References tbb::interface10::internal::concurrent_skip_list< Traits >::const_range_type::my_begin, tbb::interface10::internal::concurrent_skip_list< Traits >::const_range_type::my_end, and tbb::interface10::internal::skip_list_iterator< NodeType, is_const >::my_node_ptr.

## end()

template<typename Traits >

iterator tbb::interface10::internal::concurrent_skip_list< Traits >::const_range_type::end | ( |  | ) | const

inline

Definition at line 651 of file _concurrent_skip_list_impl.h.

{ return my_end; }

References tbb::interface10::internal::concurrent_skip_list< Traits >::const_range_type::my_end.

Referenced by tbb::interface10::internal::concurrent_skip_list< Traits >::range_type::end().

Here is the caller graph for this function:

## grainsize()

template<typename Traits >

size_t tbb::interface10::internal::concurrent_skip_list< Traits >::const_range_type::grainsize | ( |  | ) | const

inline

Definition at line 652 of file _concurrent_skip_list_impl.h.

{ return 1; }

## is_divisible()

template<typename Traits >

bool tbb::interface10::internal::concurrent_skip_list< Traits >::const_range_type::is_divisible | ( |  | ) | const

inline

Definition at line 634 of file _concurrent_skip_list_impl.h.

{
return my_level != 0 ? my_begin.my_node_ptr->next(my_level - 1) != my_end.my_node_ptr : false;
}

References tbb::interface10::internal::concurrent_skip_list< Traits >::const_range_type::my_begin, tbb::interface10::internal::concurrent_skip_list< Traits >::const_range_type::my_end, tbb::interface10::internal::concurrent_skip_list< Traits >::const_range_type::my_level, and tbb::interface10::internal::skip_list_iterator< NodeType, is_const >::my_node_ptr.

## size()

template<typename Traits >

size_type tbb::interface10::internal::concurrent_skip_list< Traits >::const_range_type::size | ( |  | ) | const

inline

Definition at line 638 of file _concurrent_skip_list_impl.h.

{ return std::distance(my_begin, my_end);}

References tbb::interface10::internal::concurrent_skip_list< Traits >::const_range_type::my_begin, and tbb::interface10::internal::concurrent_skip_list< Traits >::const_range_type::my_end.

## Member Data Documentation

## my_begin

template<typename Traits >

const_iterator tbb::interface10::internal::concurrent_skip_list< Traits >::const_range_type::my_begin

private

Definition at line 625 of file _concurrent_skip_list_impl.h.

Referenced by tbb::interface10::internal::concurrent_skip_list< Traits >::const_range_type::begin(), tbb::interface10::internal::concurrent_skip_list< Traits >::const_range_type::const_range_type(), tbb::interface10::internal::concurrent_skip_list< Traits >::const_range_type::empty(), tbb::interface10::internal::concurrent_skip_list< Traits >::const_range_type::is_divisible(), and tbb::interface10::internal::concurrent_skip_list< Traits >::const_range_type::size().

## my_end

template<typename Traits >

const_iterator tbb::interface10::internal::concurrent_skip_list< Traits >::const_range_type::my_end

private

Definition at line 624 of file _concurrent_skip_list_impl.h.

Referenced by tbb::interface10::internal::concurrent_skip_list< Traits >::const_range_type::const_range_type(), tbb::interface10::internal::concurrent_skip_list< Traits >::const_range_type::empty(), tbb::interface10::internal::concurrent_skip_list< Traits >::const_range_type::end(), tbb::interface10::internal::concurrent_skip_list< Traits >::const_range_type::is_divisible(), and tbb::interface10::internal::concurrent_skip_list< Traits >::const_range_type::size().

## my_level

template<typename Traits >

size_type tbb::interface10::internal::concurrent_skip_list< Traits >::const_range_type::my_level

private

Definition at line 626 of file _concurrent_skip_list_impl.h.

Referenced by tbb::interface10::internal::concurrent_skip_list< Traits >::const_range_type::const_range_type(), and tbb::interface10::internal::concurrent_skip_list< Traits >::const_range_type::is_divisible().

The documentation for this class was generated from the following file:

- _concurrent_skip_list_impl.h

tbb::interface10::internal::skip_list_iterator::my_node_ptr
node_ptr my_node_ptr
Definition: _concurrent_skip_list_impl.h:192
tbb::interface10::internal::concurrent_skip_list::const_range_type::iterator
typename concurrent_skip_list::const_iterator iterator
Definition: _concurrent_skip_list_impl.h:622
tbb::interface10::internal::concurrent_skip_list::const_range_type::my_end
const_iterator my_end
Definition: _concurrent_skip_list_impl.h:624
tbb::interface10::internal::concurrent_skip_list::const_range_type::my_begin
const_iterator my_begin
Definition: _concurrent_skip_list_impl.h:625
tbb::interface10::internal::concurrent_skip_list::const_range_type::my_level
size_type my_level
Definition: _concurrent_skip_list_impl.h:626

Copyright © 2005-2020 Intel Corporation. All Rights Reserved.

Intel, Pentium, Intel Xeon, Itanium, Intel XScale and VTune are registered trademarks or trademarks of Intel Corporation or its subsidiaries in the United States and other countries.

* Other names and brands may be claimed as the property of others.